#include <iostream>
#include <iomanip>  // necessário para métodos setf() de cin e ostream's
#include "matrix-01.hh"

using namespace std;

Matrix::Matrix()
{
  linhas = 0;
  colunas = 0;
  mat = NULL;
}

Matrix::Matrix(int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new MAT_TYPE* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new MAT_TYPE[colunas];
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(MAT_TYPE **newmat, int lins, int cols)
{
  linhas = lins;
  colunas = cols;
  mat = newmat;
  
/* int i, k;

   mat = new MAT_TYPE* [linhas];
   for (i=0; i < linhas; i++) {
      mat[i] = new MAT_TYPE[colunas];
      for (k=0; k < colunas; k++)
         mat[i][k] = newmat[i][k];
   }
*/
}

MAT_TYPE* Matrix::operator [](const int i) const
{
  return mat[i];
}

// void Matrix::entrada ()
istream& operator >> (istream& s, Matrix& mat)
{
  int i, k;

  for (i=0; i < mat.linhas; i++)
    for (k=0; k < mat.colunas; k++)
      s >> mat.mat[i][k];

  return s;
}

// void Matrix::saida ()
ostream& operator << (ostream& s, Matrix& mat)
{
  int i, k;

  // s.setf(ios::showpoint|ios::fixed);
  // s.precision(2);

  for (i=0; i < mat.linhas; i++) {
    for (k=0; k < mat.colunas; k++)
      s << setw(5) << mat.mat[i][k];
    s << endl;
  }

  return s;
}

Matrix Matrix::add (const Matrix& mat_2, char op)
{
  // ********************************************
  // FALTA TESTAR SE mat_1.linhasxcolunas == mat_2.linhasxcolunas
  // FAZER ISTO VIA EXCECAO
  // ********************************************

  int i, k;
  MAT_TYPE **soma = new MAT_TYPE* [linhas];

  op = (op == '+') ? 1:-1;

  for (i=0; i < linhas; i++)
    soma[i] = new MAT_TYPE [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      soma[i][k] = mat[i][k] + (int) op * mat_2.mat[i][k];
  
  return (Matrix(soma, linhas, colunas));
}

Matrix Matrix::operator+ (const Matrix& mat_2)
{
  return (add(mat_2, '+'));
}

Matrix Matrix::operator- (const Matrix& mat_2)
{
  return (add(mat_2, '-'));
}

Matrix Matrix::operator* (const float escalar)
{
  int i, k;
  MAT_TYPE **prod = new MAT_TYPE* [linhas];

  for (i=0; i < linhas; i++)
    prod[i] = new MAT_TYPE [colunas];

  for (i=0; i < linhas; i++)
    for (k=0; k < colunas; k++)
      prod[i][k] = escalar * mat[i][k];
  
  return (Matrix(prod, linhas, colunas));
}

Matrix operator* (const float escalar, Matrix& mat_1)
{
  return (mat_1 * escalar);
}

Matrix Matrix::operator* (const Matrix& mat_2)
{
  // ********************************************
  // FALTA TESTAR SE mat_1.colunas == mat_2.linhas
  // FAZER ISTO VIA EXCECAO
  // ********************************************

  int i,j,p,q;
  MAT_TYPE **prod = new MAT_TYPE* [linhas];

  for (i=0; i < linhas; i++) {
    prod[i] = new MAT_TYPE [mat_2.colunas];
    for (j=0; j < mat_2.colunas; j++)
      prod[i][j] = 0;
  }

  for (i=0; i < linhas; i++)
    for (j=0; j < mat_2.colunas; j++) {
      for (p=0; p < colunas; p++)
	prod[i][j] += mat[i][p] * mat_2.mat[p][j];
    }
  
  return (Matrix(prod, linhas, mat_2.colunas));
}

